package net.maunium.Maucros.ASM;

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.IOException;
import java.net.NetworkInterface;
import java.util.Collections;
import java.util.Map;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTextField;

import org.jasypt.encryption.Restrictions;

import net.maunium.Maucros.ASM.transformers.BlockFluidRendererT;
import net.maunium.Maucros.ASM.transformers.BlockModelRendererT;
import net.maunium.Maucros.ASM.transformers.BlockT;
import net.maunium.Maucros.ASM.transformers.EnchantmentT;
import net.maunium.Maucros.ASM.transformers.EntityPlayerSPT;
import net.maunium.Maucros.ASM.transformers.EntityPlayerT;
import net.maunium.Maucros.ASM.transformers.NetworkManagerT;
import net.maunium.Maucros.Misc.MaucrosLicensor;

import net.minecraft.client.Minecraft;

import net.minecraftforge.fml.relauncher.IFMLLoadingPlugin;
import net.minecraftforge.fml.relauncher.IFMLLoadingPlugin.MCVersion;
import net.minecraftforge.fml.relauncher.IFMLLoadingPlugin.Name;

@MCVersion(value = "1.8")
@Name(value = "Maucros Core")
public class MaucrosCoreLoader implements IFMLLoadingPlugin {
	
	private JFrame frame;
	private JTextField mac, licence;
	private JButton finish;
	private JLabel label;
	
	public MaucrosCoreLoader() {
		Restrictions.remove();
		try {
			MaucrosLicensor.loadLicences();
			MaucrosLicensor.query();
		} catch (Exception e) {
			e.printStackTrace();
			return;
		}
		if (MaucrosLicensor.isKillswitched())
			JOptionPane.showMessageDialog(null, "The version of Maucros that you\n" + "are using has been killswitched", "Killswitched",
					JOptionPane.ERROR_MESSAGE);
		if (!MaucrosLicensor.isLicenced()) {
			initFrame();
			frame.setVisible(true);
		}
	}
	
	private void initFrame() {
		frame = new JFrame("Maucros Licencer");
		frame.setLayout(null);
		frame.setSize(new Dimension(276, 153));
		frame.setLocationRelativeTo(null);
		frame.setAlwaysOnTop(true);
		label = new JLabel("Please enter your Maucros licence");
		licence = new JTextField();
		finish = new JButton("Save and Quit");
		finish.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				if (!licence.getText().isEmpty()) {
					String ud = System.getProperty("user.dir");
					File f = new File(ud + File.separator + "config" + File.separator + "Maucros" + File.separator + "licences.maudat");
					try {
						MaucrosLicensor.addLicence(mac.getText().substring(11), licence.getText());
						MaucrosLicensor.saveLicences();
					} catch (IOException e1) {
						e1.printStackTrace();
					}
					stop();
				}
			}
		});
		label.setSize(250, 20);
		licence.setSize(250, 20);
		finish.setSize(250, 30);
		label.setLocation(5, 5);
		licence.setLocation(5, 55);
		finish.setLocation(5, 80);
		try {
			NetworkInterface net = null;
			for (NetworkInterface ni : Collections.list(NetworkInterface.getNetworkInterfaces())) {
				if (!ni.isUp() || ni.isVirtual() || ni.isLoopback() || ni.isPointToPoint()) continue;
				net = ni;
				break;
			}
			if (net == null) return;
			byte[] macB = net.getHardwareAddress();
			StringBuilder sb = new StringBuilder();
			for (int i = 0; i < macB.length; i++)
				sb.append(String.format("%02X%s", macB[i], i < macB.length - 1 ? "-" : ""));
			String lmac = sb.toString();
			mac = new JTextField("Local MAC: " + lmac);
		} catch (Exception e) {
			mac = new JTextField("Error trying to get Local MAC");
		}
		mac.setEditable(false);
		mac.setLocation(5, 30);
		mac.setSize(250, 20);
		
		frame.add(label);
		frame.add(mac);
		frame.add(licence);
		frame.add(finish);
	}
	
	private synchronized void stop() {
		if (Minecraft.getMinecraft() != null) Minecraft.getMinecraft().shutdown();
		else while (true) {
			try {
				Thread.sleep(500);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
			if (Minecraft.getMinecraft() != null) Minecraft.getMinecraft().shutdown();
		}
	}
	
	@Override
	public String[] getASMTransformerClass() {
		return new String[] { BlockModelRendererT.class.getName(), BlockFluidRendererT.class.getName(), BlockT.class.getName(),
				NetworkManagerT.class.getName(), EntityPlayerSPT.class.getName(), EntityPlayerT.class.getName(), EnchantmentT.class.getName() };
	}
	
	@Override
	public String getModContainerClass() {
		return null;
	}
	
	@Override
	public String getSetupClass() {
		return null;
	}
	
	@Override
	public void injectData(Map<String, Object> data) {}
	
	@Override
	public String getAccessTransformerClass() {
		return MaucrosAccessTransformer.class.getName();
	}
}
