package net.maunium.Maucros.ASM.transformers;

import java.util.Iterator;

import org.objectweb.asm.ClassReader;
import org.objectweb.asm.ClassWriter;
import org.objectweb.asm.Opcodes;
import org.objectweb.asm.tree.AbstractInsnNode;
import org.objectweb.asm.tree.ClassNode;
import org.objectweb.asm.tree.MethodInsnNode;
import org.objectweb.asm.tree.MethodNode;

import net.maunium.Maucros.ASM.AbstractMauTransformer;
import net.maunium.Maucros.Gui.GuiSpawnItem;

public class EnchantmentT extends AbstractMauTransformer {
	
	public EnchantmentT() {
		super("net.minecraft.enchantment.Enchantment", "apf");
	}
	
	@Override
	public byte[] transform(byte[] bytes, boolean obf) {
		long st = System.currentTimeMillis();
		String methodName = obf ? "d" : "getTranslatedName";
		String desc = "(I)Ljava/lang/String;";
		log.info("Going to patch " + methodName + "(int level) in class " + getName(obf) + "...");
		
		log.trace("Creating ClassNode");
		ClassNode node = new ClassNode();
		log.trace("Creating ClassReader");
		ClassReader cr = new ClassReader(bytes);
		log.trace("Accepting node to reader");
		cr.accept(node, 0);
		
		for (MethodNode m : node.methods) {
			if (m.name.equals(methodName) && m.desc.equals(desc)) {
				log.info("Found method " + m.name + " with desc " + m.desc + ".");
				AbstractInsnNode current = null;
				
				Iterator<AbstractInsnNode> iter = m.instructions.iterator();
				boolean b = false;
				while (iter.hasNext()) {
					current = iter.next();
					if (b && current.getOpcode() == Opcodes.NEW) break;
					else if (current.getOpcode() == Opcodes.NEW) b = true;
				}
				if(current == null) throw new RuntimeException("Could not find correct position!");
				m.instructions.remove(current);
				m.instructions.remove(iter.next());
				m.instructions.remove(iter.next());
				m.instructions.remove(iter.next());
				m.instructions.remove(iter.next());
				AbstractInsnNode insertat = iter.next();
				m.instructions.remove(iter.next());
				m.instructions.remove(iter.next());
				m.instructions.remove(iter.next());
				m.instructions.insert(insertat, new MethodInsnNode(Opcodes.INVOKESTATIC, GuiSpawnItem.class.getName().replace(".", "/"), "toRoman", "(I)Ljava/lang/String;", false));
				break;
			}
		}
		
		log.debug("Writing changes...");
		ClassWriter cw = new ClassWriter(ClassWriter.COMPUTE_MAXS | ClassWriter.COMPUTE_FRAMES);
		node.accept(cw);
		long tt = System.currentTimeMillis() - st;
		log.info("Patching complete in " + tt + "ms. Returning patched class.");
		return cw.toByteArray();
	}
}
