package net.maunium.Maucros.Actions;

import java.util.List;

import net.maunium.Maucros.Config.Settings;

import net.minecraft.client.Minecraft;
import net.minecraft.client.entity.EntityPlayerSP;
import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.projectile.EntityFireball;
import net.minecraft.util.AxisAlignedBB;
import net.minecraft.util.EnumChatFormatting;

public class ActionAttackaura extends DelayAction {
	public ActionAttackaura() {
		super("Attackaura");
	}

	@Override
	public void executeChecked() {
		EntityPlayerSP p = Minecraft.getMinecraft().thePlayer;
		List<Entity> entities = getEntitiesAABB(EntityFireball.class, Settings.Attacking.range);
		for (Class<? extends EntityLivingBase> c : Settings.Attacking.getTargets())
			entities.addAll(getEntitiesAABB(c, Settings.Attacking.range));
		boolean swing = false;
		for (Entity e : entities) {
			if (e instanceof EntityPlayer) {
				EntityPlayer b = (EntityPlayer) e;
				if (Settings.Friends.isFriend(b.getName()) || b.equals(p)) continue;
			}
			Minecraft.getMinecraft().playerController.attackEntity(p, e);
			if (!swing) {
				p.swingItem();
				swing = true;
			}
		}
	}
	
	private List<Entity> getEntitiesAABB(Class<?> c, double range) {
		EntityPlayerSP p = Minecraft.getMinecraft().thePlayer;
		List<Entity> l = p.worldObj.getEntitiesWithinAABB(c,
				AxisAlignedBB.fromBounds(p.posX - range, p.posY - range, p.posZ - range, p.posX + range, p.posY + range, p.posZ + range));
		return l;
	}
	
	@Override
	public int refreshDelay() {
		return Settings.Delay.attackaura;
	}

	@Override
	public void renderText(List<String> str) {
		str.add("Attack Aura " + EnumChatFormatting.GREEN + "ON");
		if (Settings.Attacking.range <= 6) str.add(" Range: " + EnumChatFormatting.GREEN + Settings.Attacking.range);
		else str.add(" Range: " + EnumChatFormatting.GREEN + EnumChatFormatting.ITALIC + Settings.Attacking.range);
		
		if (Settings.Delay.attackaura >= 20) str.add(" Speed (ms/hit): " + EnumChatFormatting.GREEN + Settings.Delay.attackaura);
		else str.add(" Speed (ms/hit): " + EnumChatFormatting.GREEN + EnumChatFormatting.ITALIC + Settings.Delay.attackaura);
	}
}
