package net.maunium.Maucros.Actions;

import java.util.List;

import org.lwjgl.input.Keyboard;

import net.maunium.Maucros.Maucros;
import net.maunium.Maucros.Config.Settings;
import net.maunium.Maucros.Misc.MaucrosLicensor;

import net.minecraft.client.Minecraft;
import net.minecraft.client.entity.EntityPlayerSP;
import net.minecraft.client.settings.KeyBinding;
import net.minecraft.network.play.client.C03PacketPlayer;
import net.minecraft.util.EnumChatFormatting;
import net.minecraft.util.MathHelper;

public class ActionPhase extends Action {
	public ActionPhase() {
		super("Phase");
	}
	
	@Override
	public void execute() {
		// Is shift down? If yes, stop phasing
		if (Keyboard.isKeyDown(Keyboard.KEY_LSHIFT)) stopPhase();
		// Start automated phasing
		else if (Settings.Phase.automated) autophase();
		// Do a single manual phase
		else manualphase();
	}
	
	public void manualphase() {
		EntityPlayerSP p = Minecraft.getMinecraft().thePlayer;
		int look = MathHelper.floor_double(p.rotationYaw * 4.0F / 360.0F + 0.5D) & 3;
		phase(p, look);
	}
	
	private PhaseThread pt = null;
	
	public boolean isPhasing() {
		return pt != null && pt.isAlive();
	}
	
	@SuppressWarnings("deprecation")
	public void autophase() {
		if (!MaucrosLicensor.check()) return;
		if (pt != null && pt.isAlive()) {
			pt.stop();
			pt = null;
		}
		pt = new PhaseThread();
		pt.start();
	}
	
	@SuppressWarnings("deprecation")
	public void stopPhase() {
		if (pt != null && pt.isAlive()) {
			pt.stop();
			pt = null;
			KeyBinding.setKeyBindState(Minecraft.getMinecraft().gameSettings.keyBindForward.getKeyCode(), false);
		}
	}
	
	public class PhaseThread extends Thread {
		
		public PhaseThread() {
			super("Phase Thread");
		}
		
		private boolean forwardState = true;
		
		@Override
		public void run() {
			EntityPlayerSP p = Minecraft.getMinecraft().thePlayer;
			int look = MathHelper.floor_double(p.rotationYaw * 4.0F / 360.0F + 0.5D) & 3;
			double target;
			Maucros.getLogger().debug("Attempting to phase through block. Direction: F" + look);
			if (look == 0) {
				target = p.posZ + 1;
				while (p.posZ < target) {
					phase(p, look);
					phase2();
				}
			} else if (look == 1) {
				target = p.posX - 1;
				while (p.posX > target) {
					phase(p, look);
					phase2();
				}
			} else if (look == 2) {
				target = p.posZ - 1;
				while (p.posZ > target) {
					phase(p, look);
					phase2();
				}
			} else if (look == 3) {
				target = p.posX + 1;
				while (p.posX < target) {
					phase(p, look);
					phase2();
				}
			}
			KeyBinding.setKeyBindState(Minecraft.getMinecraft().gameSettings.keyBindForward.getKeyCode(), false);
			Maucros.getLogger().trace("Phasing complete");
		}
		
		private void phase2() {
			if (!Settings.Phase.autoforward) {
				sleep();
				return;
			}
			EntityPlayerSP p = Minecraft.getMinecraft().thePlayer;
			p.setSprinting(!p.isSprinting());
			KeyBinding.setKeyBindState(Minecraft.getMinecraft().gameSettings.keyBindForward.getKeyCode(), forwardState);
			if (forwardState) forwardState = false;
			else forwardState = true;
			sleep();
		}
		
		private void sleep() {
			try {
				Thread.sleep(200);
			} catch (InterruptedException e) {}
		}
	};
	
	private void phase(EntityPlayerSP p, int dir) {
		if (dir == 0) {
			for (int i = 0; i < 4; i++)
				p.sendQueue.addToSendQueue(new C03PacketPlayer.C04PacketPlayerPosition(p.posX, p.posY, p.posZ + 0.6, p.onGround));
			p.sendQueue.addToSendQueue(new C03PacketPlayer.C04PacketPlayerPosition(p.posX, p.posY - 0.5, p.posZ, p.onGround));
			p.posZ += 2.4;
			p.posY -= 0.5;
		} else if (dir == 1) {
			for (int i = 0; i < 4; i++)
				p.sendQueue.addToSendQueue(new C03PacketPlayer.C04PacketPlayerPosition(p.posX - 0.6, p.posY, p.posZ, p.onGround));
			p.sendQueue.addToSendQueue(new C03PacketPlayer.C04PacketPlayerPosition(p.posX, p.posY - 0.5, p.posZ, p.onGround));
			p.posX -= 2.4;
			p.posY -= 0.5;
		} else if (dir == 2) {
			for (int i = 0; i < 4; i++)
				p.sendQueue.addToSendQueue(new C03PacketPlayer.C04PacketPlayerPosition(p.posX, p.posY, p.posZ - 0.6, p.onGround));
			p.sendQueue.addToSendQueue(new C03PacketPlayer.C04PacketPlayerPosition(p.posX, p.posY - 0.5, p.posZ, p.onGround));
			p.posZ -= 2.4;
			p.posY -= 0.5;
		} else if (dir == 3) {
			for (int i = 0; i < 4; i++)
				p.sendQueue.addToSendQueue(new C03PacketPlayer.C04PacketPlayerPosition(p.posX + 0.6, p.posY, p.posZ, p.onGround));
			p.sendQueue.addToSendQueue(new C03PacketPlayer.C04PacketPlayerPosition(p.posX, p.posY - 0.5, p.posZ, p.onGround));
			p.posX += 2.4;
			p.posY -= 0.5;
		}
	}
	
	@Override
	public void renderText(List<String> str) {
		str.add("Automated Phase " + EnumChatFormatting.GREEN + "ON");
		if (Settings.Phase.autoforward) str.add(" Auto-forward: " + EnumChatFormatting.GREEN + "ON");
		else str.add(" Auto-forward: " + EnumChatFormatting.RED + "OFF");
	}
}
