package net.maunium.Maucros.Config;

import java.net.InetSocketAddress;

import net.minecraft.client.multiplayer.ServerAddress;
import net.minecraft.client.multiplayer.ServerData;

public class ServerInfo {
	private static ServerInfo currentServer = null;
	public final String ip;
	public final int port;
	
	public ServerInfo(String ip, int port) {
		this.ip = ip;
		this.port = port;
	}
	
	@Override
	public String toString() {
		return ip + ":" + port;
	}
	
	public static ServerInfo valueOf(InetSocketAddress address) {
		return new ServerInfo(address.getHostString(), address.getPort());
	}
	
	public static ServerInfo valueOf(ServerData data) {
		ServerAddress address = ServerAddress.func_78860_a(data.serverIP);
		return new ServerInfo(address.getIP(), address.getPort());
	}
	
	public static void setCurrent(ServerInfo info) {
		currentServer = info;
	}
	
	public static void clearCurrent() {
		currentServer = null;
	}
	
	public static boolean hasCurrent(){
		return currentServer != null;
	}
	
	public static ServerInfo getCurrent() {
		return currentServer;
	}
}