package net.maunium.Maucros.Gui.Alts;

import org.lwjgl.input.Keyboard;

import com.mcf.davidee.guilib.basic.Label;
import com.mcf.davidee.guilib.core.Button;
import com.mcf.davidee.guilib.core.Container;
import com.mcf.davidee.guilib.vanilla.ButtonVanilla;
import com.mcf.davidee.guilib.vanilla.TextFieldVanilla;

import net.maunium.Maucros.Maucros;
import net.maunium.Maucros.Config.Settings;
import net.maunium.Maucros.Gui.MauScreen;
import net.maunium.Maucros.Gui.Widgets.CommonFilter;
import net.maunium.Maucros.Misc.I18n;

public class GuiAddAlt extends MauScreen {
	
	private Container c;
	private ButtonVanilla add, cancel;
	private TextFieldVanilla username, password;
	private Label title, unLabel, pwLabel;
	
	public GuiAddAlt(GuiAlts parent) {
		super(parent);
	}
	
	@Override
	public void onButtonClicked(Button button) {
		if (username.getText().trim().isEmpty() || password.getText().trim().isEmpty()) add.setEnabled(false);
		else add.setEnabled(true);
		if (button.equals(add)) add();
		else if (button.equals(cancel)) close();
	}
	
	private void add() {
		if (!username.getText().trim().isEmpty() && !password.getText().trim().isEmpty()) {
			Settings.Alts.addAlt(username.getText().trim(), password.getText().trim());
			close();
			if (getParent() instanceof GuiAlts) ((GuiAlts) getParent()).revalidateGui();
			else Maucros.getLogger().warning("[GuiAddAlt] My parent isn't GuiAlts? Something may be wrong!");
		}
	}
	
	@Override
	public void onKeyTyped(char c, int kc) {
		if (kc == Keyboard.KEY_RETURN) add();
		else super.onKeyTyped(c, kc);
		if (username.getText().trim().isEmpty() || password.getText().trim().isEmpty()) add.setEnabled(false);
		else add.setEnabled(true);
	}
	
	@Override
	public void onReval() {
		int xp1 = width / 2 - 150 - 12;
		int xp2 = width / 2 + 12;
		int xpl = width / 2 - 210 / 2;
		int xpt = xpl + 60;
		int mod = 25;
		
		Maucros.getLogger().trace("Setting positions", this);
		title.setPosition(width / 2, 15);
		
		username.setPosition(xpt, mod * 2);
		password.setPosition(xpt, mod * 3);
		
		unLabel.setPosition(xpl, mod * 2);
		pwLabel.setPosition(xpl, mod * 3);
		
		add.setPosition(xp1, mod * 4);
		cancel.setPosition(xp2, mod * 4);
		
		if (username.getText().trim().isEmpty() || password.getText().trim().isEmpty()) add.setEnabled(false);
		else add.setEnabled(true);
		
		Maucros.getLogger().trace("Revalidating container", this);
		c.revalidate(0, 0, width, height);
	}
	
	@Override
	public void onInit() {
		Maucros.getLogger().trace("Creating text fields", this);
		username = new TextFieldVanilla(new TextFieldVanilla.VanillaFilter());
		password = new TextFieldVanilla(new CommonFilter());
		
		Maucros.getLogger().trace("Creating labels", this);
		title = new Label(I18n.format("conf.alts.add.title"));
		unLabel = new Label(I18n.format("conf.alts.add.username"));
		pwLabel = new Label(I18n.format("conf.alts.add.password"));
		
		Maucros.getLogger().trace("Creating buttons", this);
		add = new ButtonVanilla(150, 20, I18n.format("conf.alts.add.add"), this);
		cancel = new ButtonVanilla(150, 20, I18n.format("conf.alts.add.cancel"), this);
		
		Maucros.getLogger().trace("Creating container and adding widgets", this);
		c = new Container();
		c.addWidgets(add, cancel, username, password, unLabel, pwLabel);
		Maucros.getLogger().trace("Adding container", this);
		containers.add(c);
	}
	
	@Override
	public void onReopen() {
		Maucros.getLogger().debug("Reopened GUI", this);
		if (username.getText().trim().isEmpty() || password.getText().trim().isEmpty()) add.setEnabled(false);
		else add.setEnabled(true);
	}
}
