package net.maunium.Maucros.Gui.Alts;

import java.io.IOException;

import org.lwjgl.input.Keyboard;

import com.mcf.davidee.guilib.basic.FocusedContainer;
import com.mcf.davidee.guilib.basic.Label;
import com.mcf.davidee.guilib.core.Button;
import com.mcf.davidee.guilib.core.Container;
import com.mcf.davidee.guilib.vanilla.ButtonVanilla;
import com.mcf.davidee.guilib.vanilla.ScrollbarVanilla;

import net.maunium.Maucros.Maucros;
import net.maunium.Maucros.Config.Configurations;
import net.maunium.Maucros.Config.Settings;
import net.maunium.Maucros.Gui.MauScreen;
import net.maunium.Maucros.Gui.Widgets.FixedFocusableLabel;
import net.maunium.Maucros.Gui.Widgets.ShiftableLabel;
import net.maunium.Maucros.Misc.I18n;

import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.Gui;

public class GuiAlts extends MauScreen {
	
	private Container c;
	private FocusedContainer alts;
	private ScrollbarVanilla sb;
	private Label title;
	private FixedFocusableLabel[] usernames;
	private ShiftableLabel[] passwords;
	private ButtonVanilla select, back, delete, add;
	private GuiChangeUsername parent;
	
	public GuiAlts(GuiChangeUsername parent) {
		super(parent);
		this.parent = parent;
	}
	
	@Override
	public void onInit() {
		Maucros.getLogger().trace("Creating title", this);
		title = new Label(I18n.format("conf.alts.title"));
		Maucros.getLogger().trace("Creating buttons", this);
		add = new ButtonVanilla(150, 20, I18n.format("conf.alts.add"), this);
		delete = new ButtonVanilla(150, 20, I18n.format("conf.alts.delete"), this);
		select = new ButtonVanilla(150, 20, I18n.format("conf.alts.select"), this);
		back = new ButtonVanilla(150, 20, I18n.format("conf.back"), this);
		
		Maucros.getLogger().trace("Creating alt container", this);
		sb = new ScrollbarVanilla(10);
		alts = new FocusedContainer(sb, 14, 4);
		
		Maucros.getLogger().trace("Creating main container and adding widgets", this);
		c = new Container();
		c.addWidgets(title, select, back, delete, add);
		Maucros.getLogger().trace("Adding containers to list", this);
		containers.add(alts);
		containers.add(c);
	}
	
	@Override
	public void onReval() {
		int xp1 = width / 2 - 150 - 12;
		int xp2 = width / 2 + 12;
		int mod = 25;
		
		Maucros.getLogger().trace("Setting positions", this);
		title.setPosition(width / 2, 15);
		add.setPosition(xp1, mod * 6);
		delete.setPosition(xp2, mod * 6);
		select.setPosition(xp1, mod * 7);
		back.setPosition(xp2, mod * 7);
		
		Maucros.getLogger().trace("Refreshing alt list", this);
		alts.getWidgets().clear();
		alts.getFocusableWidgets().clear();
		usernames = new FixedFocusableLabel[Settings.Alts.getAlts().size()];
		passwords = new ShiftableLabel[Settings.Alts.getAlts().size()];
		int i = 0;
		for (String s : Settings.Alts.getAlts()) {
			Maucros.getLogger().trace("Adding entry for alt " + s, this);
			usernames[i] = new FixedFocusableLabel(s, false);
			passwords[i] = new ShiftableLabel(Settings.Alts.getPassword(s), false);
			usernames[i].setPosition(width / 2 - (xp2 + 150 - xp1) / 2 + 2, 32 + i * 10);
			passwords[i].setPosition(width / 2 + 2, 32 + i * 10);
			i++;
		}
		alts.addWidgets(usernames);
		alts.addWidgets(passwords);
		
		sb.setPosition(xp2 + 140, 30);
		Maucros.getLogger().trace("Revalidating containers", this);
		c.revalidate(0, 0, width, height);
		alts.revalidate(xp1, 30, xp2 + 150 - xp1 - 10, mod * 4);
	}
	
	@Override
	public void drawBackground() {
		super.drawBackground();
		Gui.drawRect(alts.left(), alts.top(), alts.right(), alts.bottom(), 0x44444444);
	}
	
	@Override
	public void onKeyTyped(char c, int kc) {
		if (kc == Keyboard.KEY_RETURN) select();
		else if (kc == Keyboard.KEY_DELETE) delete();
		else if (kc == Keyboard.KEY_ADD) Minecraft.getMinecraft().displayGuiScreen(new GuiAddAlt(this));
		else super.onKeyTyped(c, kc);
		
	}
	
	@Override
	public void save(){
		try {
			Configurations.Alts.save();
		} catch (IOException e) {
			Maucros.getLogger().warning("Failed to save alt list!");
			Maucros.getLogger().catching(e);
		}
	}
	
	private void select() {
		for (int i = 0; i < usernames.length; i++)
			if (usernames[i].equals(alts.getFocusedWidget())) {
				parent.username.setText(usernames[i].getText());
				parent.password.setText(passwords[i].getText());
			}
		close();
	}
	
	private void delete() {
		if (alts.getFocusedWidget() instanceof FixedFocusableLabel) {
			FixedFocusableLabel l = (FixedFocusableLabel) alts.getFocusedWidget();
			Settings.Alts.delAlt(l.getText());
			revalidateGui();
		}
	}
	
	@Override
	public void onButtonClicked(Button button) {
		if (button.equals(select)) select();
		else if (button.equals(delete)) delete();
		else if (button.equals(back)) close();
		else if (button.equals(add)) Minecraft.getMinecraft().displayGuiScreen(new GuiAddAlt(this));
	}
}
