package net.maunium.Maucros.Gui.Config;

import com.mcf.davidee.guilib.basic.Label;
import com.mcf.davidee.guilib.core.Button;
import com.mcf.davidee.guilib.core.Container;
import com.mcf.davidee.guilib.vanilla.ButtonVanilla;
import com.mcf.davidee.guilib.vanilla.TextFieldVanilla;

import net.maunium.Maucros.Config.Settings;
import net.maunium.Maucros.Gui.MauScreen;
import net.maunium.Maucros.Gui.Widgets.CommonFilter;
import net.maunium.Maucros.Gui.Widgets.StateButton;
import net.maunium.Maucros.Misc.I18n;

/**
 * @author Tulir293
 * @since 1.5 Alpha 7
 */
public class GuiEncryption extends MauScreen {
	private Container c;
	private TextFieldVanilla password, salt;
	private StateButton output;
	private ButtonVanilla back;
	private Label title, passwordLabel, saltLabel;
	
	public GuiEncryption(GuiConfig parent) {
		super(parent);
	}
	
	@Override
	public void onInit() {
		title = new Label(I18n.format("conf.encryption.title"));
		back = new ButtonVanilla(200, 20, I18n.format("conf.back"), this);
		password = new TextFieldVanilla(200, 20, new CommonFilter());
		password.setText(Settings.Encryption.password);
		passwordLabel = new Label(I18n.format("conf.encryption.password"), false);
		salt = new TextFieldVanilla(150, 20, new CommonFilter());
		salt.setText(Settings.Encryption.salt);
		saltLabel = new Label(I18n.format("conf.encryption.salt"), false);
		output = new StateButton(200, 20, this, Settings.Encryption.base64 ? 0 : 1, new StateButton.GenericFormat(I18n.format("conf.encryption.output"),
				I18n.format("conf.encryption.base64"), I18n.format("conf.encryption.hexadecimal")));
		
		c = new Container();
		c.addWidgets(title, password, salt, passwordLabel, saltLabel, output, back);
		containers.add(c);
	}
	
	@Override
	public void onReval() {
		title.setPosition(width / 2, 15);
		
		passwordLabel.setPosition(width / 6, 52);
		saltLabel.setPosition(width / 6, 82);
		
		password.setPosition(width / 3, 50);
		salt.setPosition(width / 3, 80);
		output.setPosition(width / 2 - 100, 110);
		
		back.setPosition(width / 2 - 100, 200);
		
		c.revalidate(0, 0, width, height);
	}
	
	@Override
	public void onButtonClicked(Button b){
		this.close();
	}
	
	@Override
	public void save() {
		Settings.Encryption.password = password.getText();
		Settings.Encryption.salt = salt.getText();
		Settings.Encryption.base64 = output.getState() == 0;
	}
}
