package net.maunium.Maucros.Gui.Config;

import com.mcf.davidee.guilib.basic.Label;
import com.mcf.davidee.guilib.core.Button;
import com.mcf.davidee.guilib.core.Container;
import com.mcf.davidee.guilib.core.TextField;
import com.mcf.davidee.guilib.vanilla.ButtonVanilla;
import com.mcf.davidee.guilib.vanilla.TextFieldVanilla;

import net.maunium.Maucros.Maucros;
import net.maunium.Maucros.Config.Settings;
import net.maunium.Maucros.Gui.MauScreen;
import net.maunium.Maucros.Gui.Widgets.CommonFilter;
import net.maunium.Maucros.Misc.I18n;

public class GuiScreenshot extends MauScreen {
	private Container c;
	private Label title;
	
	private Button back;
	private Label ipl, portl, passl;
	private TextField ip, port, pass;
	
	public GuiScreenshot(GuiConfig parent) {
		super(parent);
	}
	
	@Override
	public void onInit() {
		title = new Label(I18n.format("conf.screenshot.title"));
		
		back = new ButtonVanilla(I18n.format("conf.back"), this);
		
		Maucros.getLogger().trace("Creating labels", this);
		
		ipl = new Label(I18n.format("conf.screenshot.ip"), false);
		portl = new Label(I18n.format("conf.screenshot.port"), false);
		passl = new Label(I18n.format("conf.screenshot.pass"), false);
		
		Maucros.getLogger().trace("Creating text fields", this);
		
		ip = new TextFieldVanilla(150, 20, new CommonFilter());
		pass = new TextFieldVanilla(150, 20, new CommonFilter());
		port = new TextFieldVanilla(150, 20, new TextFieldVanilla.NumberFilter());
		port.setMaxLength(5);
		
		Maucros.getLogger().trace("Creating container", this);
		c = new Container();
		Maucros.getLogger().trace("Adding widgets", this);
		c.addWidgets(title, ip, port, pass, ipl, portl, passl, back);
		Maucros.getLogger().trace("Adding container", this);
		containers.add(c);
	}
	
	@Override
	public void onReval() {
		title.setPosition(width / 2, 15);
		int xp1 = width / 2 - 210 / 2;
		int xp2 = xp1 + 60;
		
		ipl.setPosition(xp1, 55);
		portl.setPosition(xp1, 80);
		passl.setPosition(xp1, 105);
		
		ip.setPosition(xp2, 50);
		port.setPosition(xp2, 75);
		pass.setPosition(xp2, 100);
		
		back.setPosition(width / 2 - back.getWidth() / 2, 200);
		
		c.revalidate(0, 0, width, height);
	}
	
	@Override
	public boolean onClose() {
		Settings.Screenshot.ip = ip.getText();
		if(!port.getText().isEmpty()) Settings.Screenshot.port = Integer.parseInt(port.getText());
		Settings.Screenshot.password = pass.getText();
		return true;
	}
	
	@Override
	public void onButtonClicked(Button button) {
		if (button.equals(back)) close();
	}
}
