package net.maunium.Maucros.Gui.Config;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.lwjgl.input.Keyboard;

import com.mcf.davidee.guilib.basic.Label;
import com.mcf.davidee.guilib.core.Button;
import com.mcf.davidee.guilib.core.Container;
import com.mcf.davidee.guilib.core.Widget;
import com.mcf.davidee.guilib.vanilla.ButtonVanilla;
import com.mcf.davidee.guilib.vanilla.ScrollbarVanilla;

import net.maunium.Maucros.Maucros;
import net.maunium.Maucros.Config.Configurations;
import net.maunium.Maucros.Config.Settings;
import net.maunium.Maucros.Gui.MauScreen;
import net.maunium.Maucros.Gui.Widgets.BlockSelectButton;
import net.maunium.Maucros.Misc.I18n;

import net.minecraft.block.Block;
import net.minecraft.client.Minecraft;

/**
 * 
 * @author Tulir293
 * @since 1.4 Alpha 7
 */
public class GuiXrayBlocks extends MauScreen {
	private Container c, c2;
	private ScrollbarVanilla sb;
	private Label title;
	private ButtonVanilla back, selectAll, deselectAll;
	private List<BlockSelectButton> blocks;
	
	public GuiXrayBlocks() {
		super(Minecraft.getMinecraft().currentScreen);
	}
	
	@Override
	public void onInit() {
		title = new Label(I18n.format("conf.xray.title"));
		back = new ButtonVanilla(150, 20, I18n.format("conf.back"), this);
		selectAll = new ButtonVanilla(100, 20, I18n.format("conf.xray.selectall"), this);
		deselectAll = new ButtonVanilla(100, 20, I18n.format("conf.xray.deselectall"), this);
		
		blocks = new ArrayList<BlockSelectButton>();
		Iterator<Block> i = Block.blockRegistry.iterator();
		while (i.hasNext()) {
			Block b = i.next();
			if (b != null) {
				BlockSelectButton isb = new BlockSelectButton(b, this);
				isb.setSelected(Settings.XRay.isDisabled(b));
				blocks.add(isb);
			}
		}
		sb = new ScrollbarVanilla(10);
		c2 = new Container(sb, 14, 4);
		c = new Container();
		
		c2.addWidgets(blocks.toArray(new Widget[0]));
		c.addWidgets(title, back, selectAll, deselectAll);
		containers.add(c);
		containers.add(c2);
	}
	
	@Override
	public void onButtonClicked(Button b) {
		if (b instanceof BlockSelectButton) {
			BlockSelectButton isb = (BlockSelectButton) b;
			if (isb.isSelected()) Settings.XRay.disableBlock(isb.getBase());
			else Settings.XRay.enableBlock(isb.getBase());
		} else if (b.equals(back)) close();
		else if (b.equals(deselectAll)) {
			for (BlockSelectButton bsb : blocks){
				bsb.setSelected(false);
				Settings.XRay.enableBlock(bsb.getBase());
			}
		} else if (b.equals(selectAll)) {
			for (BlockSelectButton bsb : blocks) {
				bsb.setSelected(true);
				Settings.XRay.disableBlock(bsb.getBase());
			}
		}
	}
	
	@Override
	public void save() {
		if(Settings.Enabled.xray) Minecraft.getMinecraft().renderGlobal.loadRenderers();
		try {
			Configurations.XRay.save();
		} catch (IOException e) {
			Maucros.getLogger().error("Failed to save X-Ray block config");
			Maucros.getLogger().catching(e);
		}
	}
	
	@Override
	public void onReval() {
		int y = 30;
		int d = width / 4;
		int x1 = width / 2 - BlockSelectButton.defWidth - 2;
		int x2 = width / 2 + 2;
		boolean side = true;
		for (BlockSelectButton isb : blocks) {
			isb.setPosition(side ? x1 : x2, y);
			if (side) side = false;
			else {
				side = true;
				y += 20;
			}
		}
		title.setPosition(width / 2, 15);
		back.setPosition(width / 2 - back.getWidth() / 2, 200);
		selectAll.setPosition(width / 2 - back.getWidth() / 2 - selectAll.getWidth() - 2, 200);
		deselectAll.setPosition(width / 2 + back.getWidth() / 2 + 2, 200);
		sb.setPosition(width / 2 + BlockSelectButton.defWidth + 2, 30);
		c.revalidate(0, 0, width, height);
		c2.revalidate(width / 2 - BlockSelectButton.defWidth - 3, 30, BlockSelectButton.defWidth * 2 + 4, back.getY() - 35);
	}
	
	@Override
	public void onKeyTyped(char c, int kc) {
		if (kc == Keyboard.KEY_RETURN) close();
	}
	
	@Override
	protected void mouseClicked(int mx, int my, int code) {
		if (code == 0) {
			c.mouseClicked(mx, my);
			c2.mouseClicked(mx, my);
		}
	}
}
