package net.maunium.Maucros.Gui;

import java.net.InetAddress;
import java.net.UnknownHostException;

import com.mcf.davidee.guilib.basic.Label;
import com.mcf.davidee.guilib.core.Container;
import com.mcf.davidee.guilib.vanilla.ButtonVanilla;
import com.mcf.davidee.guilib.vanilla.CheckboxVanilla;
import com.mcf.davidee.guilib.vanilla.TextFieldVanilla;
import com.mojang.authlib.GameProfile;

import net.maunium.Maucros.Maucros;
import net.maunium.Maucros.Gui.Widgets.CommonFilter;
import net.maunium.Maucros.Misc.I18n;

import net.minecraft.client.Minecraft;
import net.minecraft.network.EnumConnectionState;
import net.minecraft.network.NetworkManager;
import net.minecraft.network.ServerStatusResponse;
import net.minecraft.network.handshake.client.C00Handshake;
import net.minecraft.network.status.INetHandlerStatusClient;
import net.minecraft.network.status.client.C00PacketServerQuery;
import net.minecraft.network.status.server.S00PacketServerInfo;
import net.minecraft.network.status.server.S01PacketPong;
import net.minecraft.util.ChatComponentText;
import net.minecraft.util.IChatComponent;

public class GuiPingPong extends MauScreen {
	private static String ip = "";
	private static int port = 0;
	private Container c;
	private Label title;
	private ButtonVanilla ping, back;
	private CheckboxVanilla loop;
	private Label intervall, ipl, portl;
	private TextFieldVanilla interval, ipf, portf;
	
	public GuiPingPong() {
		super(Minecraft.getMinecraft().currentScreen);
	}
	
	@Override
	public void onInit() {
		title = new Label(I18n.format("conf.pingpong.title"));
		
		ping = new ButtonVanilla(150, 20, I18n.format("conf.pingpong.ping"), this);
		loop = new CheckboxVanilla(I18n.format("conf.pingpong.loop"), false);
		
		interval = new TextFieldVanilla(150, 20, new TextFieldVanilla.NumberFilter());
		interval.setText("1500");
		
		ipf = new TextFieldVanilla(150, 20, new CommonFilter());
		ipf.setText(ip);
		
		portf = new TextFieldVanilla(150, 20, new TextFieldVanilla.NumberFilter());
		portf.setText(Integer.toString(port));
		
		intervall = new Label(I18n.format("conf.pingpong.interval"), false);
		ipl = new Label(I18n.format("conf.pingpong.ip"), false);
		portl = new Label(I18n.format("conf.pingpong.port"), false);
		
		back = new ButtonVanilla(150, 20, I18n.format("conf.back"), this);
		
		c = new Container();
		c.addWidgets(title, ping, loop, interval, ipf, portf, intervall, ipl, portl, back);
		containers.add(c);
	}
	
	@Override
	public void onReval() {
		title.setPosition(width / 2, 15);
		
		ping.setPosition(width / 2 - 150 + 3, 200);
		back.setPosition(width / 2 - 150 - 3, 200);
		c.revalidate(0, 0, width, height);
	}
	
	public static void ping(final String ip, final int port) throws UnknownHostException {
		final NetworkManager manager = NetworkManager.provideLanClient(InetAddress.getByName(ip), port);
		manager.setNetHandler(new INetHandlerStatusClient() {
			private boolean received = false;
			
			@Override
			public void handleServerInfo(S00PacketServerInfo packet) {
				ServerStatusResponse response = packet.getResponse();
				String version = "???";
				GameProfile[] players = new GameProfile[0];
				int protocol = 0;
				int curPlayers = -1, maxPlayers = -1;
				if (response.getProtocolVersionInfo() != null) {
					protocol = response.getProtocolVersionInfo().getProtocol();
					version = response.getProtocolVersionInfo().getName();
				}
				if (response.getPlayerCountData() != null) {
					curPlayers = response.getPlayerCountData().getOnlinePlayerCount();
					maxPlayers = response.getPlayerCountData().getMaxPlayers();
					players = response.getPlayerCountData().getPlayers();
				}
				
				Maucros.getLogger().info("Server: " + ip + ":" + port);
				Maucros.getLogger().info("Protocol " + protocol + " version " + version);
				
				Maucros.getLogger().info("Players: " + curPlayers + "/" + maxPlayers);
				for(GameProfile gp : players)
					Maucros.getLogger().info(" - " + gp.getName());
				
				received = true;
			}
			
			@Override
			public void handlePong(S01PacketPong packet) {
				manager.closeChannel(new ChatComponentText("Finished"));
				
			}
			
			@Override
			public void onDisconnect(IChatComponent p_147231_1_) {
				if (!received) Maucros.getLogger().info("Ping failed");
			}
		});
		try {
			manager.sendPacket(new C00Handshake(47, ip, port, EnumConnectionState.STATUS));
			manager.sendPacket(new C00PacketServerQuery());
		} catch (Throwable t) {
			Maucros.getLogger().info("Ping failed");
			Maucros.getLogger().catching(t);
		}
	}
}
