package net.maunium.Maucros.Gui;

import com.mcf.davidee.guilib.basic.Label;
import com.mcf.davidee.guilib.core.Button;
import com.mcf.davidee.guilib.core.Container;
import com.mcf.davidee.guilib.core.Widget;
import com.mcf.davidee.guilib.vanilla.ButtonVanilla;
import com.mcf.davidee.guilib.vanilla.ScrollbarVanilla;
import com.mcf.davidee.guilib.vanilla.TextFieldVanilla;

import net.maunium.Maucros.Maucros;
import net.maunium.Maucros.Gui.Widgets.ShiftableTextField;
import net.maunium.Maucros.Misc.I18n;

import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.Gui;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.nbt.NBTTagList;
import net.minecraft.nbt.NBTTagString;
import net.minecraft.util.StatCollector;

public class GuiSpawnItem extends MauScreen {
	public GuiSpawnItem() {
		super(Minecraft.getMinecraft().currentScreen);
	}
	
	private Container c, lorec, enchantc;
	private ScrollbarVanilla loresb, enchantsb;
	private Label title, nameLabel, dNameLabel, dataValueLabel, amountLabel;
	private TextFieldVanilla name, dName, dataValue, amount;
	private ButtonVanilla addLore, addEnchant, back, spawn;
	
	private String color = String.valueOf('\u00a7');
	
	@Override
	public void onInit() {
		title = new Label(I18n.format("conf.spawnitem.title"));
		
		addLore = new ButtonVanilla(150, 20, I18n.format("conf.spawnitem.addlore"), this);
		addEnchant = new ButtonVanilla(150, 20, I18n.format("conf.spawnitem.addenchant"), this);
		
		spawn = new ButtonVanilla(150, 20, I18n.format("conf.spawnitem.spawn"), this);
		back = new ButtonVanilla(150, 20, I18n.format("conf.back"), this);
		
		loresb = new ScrollbarVanilla(10);
		enchantsb = new ScrollbarVanilla(10);
		
		c = new Container();
		c.addWidgets(title, addLore, addEnchant, spawn, back);
		lorec = new Container(loresb, 14, 12);
		enchantc = new Container(enchantsb, 14, 12);
		containers.add(c);
		containers.add(lorec);
		containers.add(enchantc);
	}
	
	@Override
	public void drawBackground() {
		super.drawBackground();
		Gui.drawRect(lorec.left(), lorec.top(), lorec.right(), lorec.bottom(), 0x44444444);
		Gui.drawRect(enchantc.left(), enchantc.top(), enchantc.right(), enchantc.bottom(), 0x44444444);
	}
	
	@Override
	public void onReval() {
		title.setPosition(width / 2, 15);
		int xp1 = width / 2 - 150 - 12;
		int xp2 = width / 2 + 12;
		
		nameLabel = new Label(I18n.format("conf.spawnitem.name"), false);
		nameLabel.setPosition(xp1, 50);
		name = new TextFieldVanilla(150 - getStringWidth(nameLabel.getText()) - 10, 20, new TextFieldVanilla.VanillaFilter());
		name.setPosition(xp1 + getStringWidth(nameLabel.getText()) + 8, 50);
		
		dNameLabel = new Label(I18n.format("conf.spawnitem.dname"), false);
		dNameLabel.setPosition(xp2, 50);
		dName = new TextFieldVanilla(150 - getStringWidth(dNameLabel.getText()) - 10, 20, new TextFieldVanilla.VanillaFilter());
		dName.setMaxLength(64);
		dName.setPosition(xp2 + getStringWidth(dNameLabel.getText()) + 8, 50);
		
		dataValueLabel = new Label(I18n.format("conf.spawnitem.datavalue"), false);
		dataValueLabel.setPosition(xp1, 78);
		dataValue = new TextFieldVanilla(150 - getStringWidth(dataValueLabel.getText()) - 10, 20, new TextFieldVanilla.NumberFilter());
		dataValue.setText("0");
		dataValue.setMaxLength(8);
		dataValue.setPosition(xp1 + getStringWidth(dataValueLabel.getText()) + 8, 75);
		
		amountLabel = new Label(I18n.format("conf.spawnitem.amount"), false);
		amountLabel.setPosition(xp2, 78);
		amount = new TextFieldVanilla(150 - getStringWidth(amountLabel.getText()) - 10, 20, new TextFieldVanilla.NumberFilter());
		amount.setText("1");
		amount.setMaxLength(3);
		amount.setPosition(xp2 + getStringWidth(amountLabel.getText()) + 8, 75);
		c.addWidgets(name, dName, dataValue, amount, nameLabel, dNameLabel, dataValueLabel, amountLabel);
		
		addEnchant.setPosition(xp1, 100);
		enchantsb.setPosition(xp1 + 140, 125);
		addLore.setPosition(xp2, 100);
		loresb.setPosition(xp2 + 140, 125);
		
		spawn.setPosition(xp1, 200);
		back.setPosition(xp2, 200);
		c.revalidate(0, 0, width, height);
		enchantc.revalidate(xp1, 125, 150, 70);
		lorec.revalidate(xp2, 125, 150, 70);
	}
	
	@Override
	protected void mouseClicked(int mx, int my, int code) {
		if (code == 0) {
			if (lorec.inBounds(mx, my)) selectedContainer = lorec;
			else if (enchantc.inBounds(mx, my)) selectedContainer = enchantc;
			else selectedContainer = c;
			c.mouseClicked(mx, my);
			lorec.mouseClicked(mx, my);
			enchantc.mouseClicked(mx, my);
		}
	}
	
	@Override
	public void onKeyTyped(char c, int kc) {
		if (selectedContainer != null) selectedContainer.keyTyped(c, kc);
	}
	
	@Override
	public void onButtonClicked(Button b) {
		
		if (b.equals(back)) this.close();
		else if (b.equals(addLore)) {
			ShiftableTextField stf = new ShiftableTextField(130, 20, new TextFieldVanilla.VanillaFilter());
			stf.setPosition(width / 2 + 16, lorec.getWidgets().size() * 25 + 130);
			stf.setMaxLength(64);
			lorec.addWidgets(stf);
			lorec.revalidate(width / 2 + 12, 125, 150, 70);
		} else if (b.equals(addEnchant)) {
			ShiftableTextField stf = new ShiftableTextField(130, 20, new TextFieldVanilla.VanillaFilter());
			stf.setPosition(width / 2 - 158, enchantc.getWidgets().size() * 25 + 130);
			enchantc.addWidgets(stf);
			enchantc.revalidate(width / 2 - 150 - 12, 125, 150, 70);
		} else if (b.equals(spawn)) {
			try {
				Object o = Item.itemRegistry.getObject(name.getText());
				if (o != null && o instanceof Item) {
					Item i = (Item) o;
					int amount = Integer.parseInt(this.amount.getText());
					int dataValue = Integer.parseInt(this.dataValue.getText());
					ItemStack is = new ItemStack(i, amount, dataValue);
					if (is.getItem() == null) {
						Maucros.printChatErrorLocalized("message.spawnitem.itemnotfound", name.getText());
						close();
						return;
					}
					is.setTagCompound(new NBTTagCompound());
					NBTTagCompound display = new NBTTagCompound();
					NBTTagList lore = new NBTTagList();
					for (Widget w : lorec.getWidgets()) {
						if (w == null || !(w instanceof ShiftableTextField)) continue;
						String text = ((ShiftableTextField) w).getText().replace("&", color).replace(color + color, "&");
						lore.appendTag(new NBTTagString(text));
					}
					if (!dName.getText().isEmpty()) display.setString("Name", dName.getText().replace("&", color).replace(color + color, "&"));
					display.setTag("Lore", lore);
					is.getTagCompound().setTag("display", display);
					
					NBTTagList enchantments = new NBTTagList();
					for (Widget w : enchantc.getWidgets()) {
						if (w == null || !(w instanceof ShiftableTextField)) continue;
						String text = ((ShiftableTextField) w).getText().trim();
						if (text.isEmpty() || !text.contains(":")) continue;
						String[] ss = text.split(":");
						ss[0] = ss[0].trim();
						ss[1] = ss[1].trim();
						if (ss[0].isEmpty()) continue;
						if (ss[1].isEmpty()) continue;
						
						short level;
						if (eqic(ss[1], "max", "maximum")) level = Short.MAX_VALUE;
						else if (eqic(ss[1], "min", "minimum")) level = Short.MIN_VALUE;
						else level = Short.parseShort(ss[1]);
						
						if (level == 0) continue;
						
						NBTTagCompound enchantment = new NBTTagCompound();
						int enchantId = enchantId(ss[0]);
						if (enchantId == -1) {
							Maucros.printChatErrorLocalized("message.spawnitem.enchant.notfound", ss[0]);
							continue;
						}
						enchantment.setShort("id", (short) enchantId);
						if (level > Short.MAX_VALUE) Maucros.printChatErrorLocalized("message.spawnitem.enchant.leveltoohigh", Short.MAX_VALUE);
						else if (level < Short.MIN_VALUE) Maucros.printChatErrorLocalized("message.spawnitem.enchant.leveltoolow", Short.MIN_VALUE);
						enchantment.setShort("lvl", level);
						enchantments.appendTag(enchantment);
					}
					is.getTagCompound().setTag("ench", enchantments);
					
					Minecraft mc = Minecraft.getMinecraft();
					if (mc.playerController.isInCreativeMode()) {
						if (mc.thePlayer.inventory.addItemStackToInventory(is)) Maucros.printChatLocalized("message.spawnitem.success",
								i.getItemStackDisplayName(is), amount);
						else Maucros.printChatErrorLocalized("message.spawnitem.fail");
					} else Maucros.printChatErrorLocalized("message.spawnitem.notcreative");
				} else Maucros.printChatErrorLocalized("message.spawnitem.itemnotfound", name.getText());
			} catch (Throwable t) {
				Maucros.printChatErrorLocalized("message.spawnitem.error", t.getMessage() == null ? "No message" : t.getMessage());
				Maucros.getLogger().catching(t);
			}
			close();
		}
	}
	
	public int enchantId(String name) {
		if (eqic(name, "protection")) return 0;
		else if (eqic(name, "fireprotection", "fire protection", "fire_protection", "fireprot")) return 1;
		else if (eqic(name, "featherfalling", "feather falling", "feather_falling")) return 2;
		else if (eqic(name, "blastprotection", "blast protection", "blast_protection", "blastprot")) return 3;
		else if (eqic(name, "projectileprotection", "projectile protection", "projectile_protection", "projprot", "projectileprot")) return 4;
		else if (eqic(name, "respiration", "waterbreathing", "water breathing")) return 5;
		else if (eqic(name, "aquaaffinity", "aqua affinity", "aqua_affinity", "waterworker", "water_worker", "water worker")) return 6;
		else if (eqic(name, "thorns", "spikes")) return 7;
		else if (eqic(name, "depthstrider", "depth_strider", "depth strider", "waterwalker", "water_walker", "water walker")) return 8;
		else if (eqic(name, "sharpness", "sharp", "damage_all", "damageall", "damage all")) return 16;
		else if (eqic(name, "smite", "damage_undead", "damageundead", "damage undead")) return 17;
		else if (eqic(name, "bane_of_arthropods", "bane of arthropods", "baneofarthropods", "boa")) return 18;
		else if (eqic(name, "knockback", "kb", "push")) return 19;
		else if (eqic(name, "fireaspect", "fire aspect", "fire_aspect", "fire", "burn", "burning")) return 20;
		else if (eqic(name, "looting", "mobloot", "moblooting")) return 21;
		else if (eqic(name, "efficiency", "breakspeed", "haste")) return 32;
		else if (eqic(name, "silktouch", "silk touch", "silk_touch")) return 33;
		else if (eqic(name, "unbreaking", "durability", "durable")) return 34;
		else if (eqic(name, "fortune", "blockloot", "blocklooting")) return 35;
		else if (eqic(name, "power", "bowdamage", "bow damage", "bow_damage")) return 48;
		else if (eqic(name, "punch", "bowknockback", "bowkb", "bowpush", "bow knockback", "bow push", "bow kb", "bow_push", "bow_kb")) return 49;
		else if (eqic(name, "flame", "bowfire", "bow fire", "bow_fire", "bow_burn", "bow burn", "bowburn")) return 50;
		else if (eqic(name, "infinity", "endless", "infinite", "arrows")) return 51;
		else if (eqic(name, "luckofthesea", "luck_of_the_sea", "luck of the sea", "sealuck", "sea luck", "sea_luck")) return 61;
		else if (eqic(name, "lure", "fishloot", "fish loot", "fish_loot")) return 62;
		return -1;
	}
	
	public boolean eqic(String s, String... compare) {
		for (String c : compare)
			if (s.equalsIgnoreCase(c)) return true;
		return false;
	}
	
	private static int getStringWidth(String text) {
		return Minecraft.getMinecraft().fontRendererObj.getStringWidth(text);
	}
	
	public static String getEnchantName(String name, int level) {
		String s = StatCollector.translateToLocal(name);
		return s + " " + GuiSpawnItem.toRoman(level);
	}
	
	public static String toRoman(int input) {
		if (input == Short.MAX_VALUE) return "Maximum";
		else if (input == Short.MIN_VALUE) return "Minimum";
		else if (input < 1 || input > 3999) return "" + input;
		StringBuffer sb = new StringBuffer();
		while (input >= 1000) {
			sb.append("M");
			input -= 1000;
		}
		while (input >= 900) {
			sb.append("CM");
			input -= 900;
		}
		while (input >= 500) {
			sb.append("D");
			input -= 500;
		}
		while (input >= 400) {
			sb.append("CD");
			input -= 400;
		}
		while (input >= 100) {
			sb.append("C");
			input -= 100;
		}
		while (input >= 90) {
			sb.append("XC");
			input -= 90;
		}
		while (input >= 50) {
			sb.append("L");
			input -= 50;
		}
		while (input >= 40) {
			sb.append("XL");
			input -= 40;
		}
		while (input >= 10) {
			sb.append("X");
			input -= 10;
		}
		while (input >= 9) {
			sb.append("IX");
			input -= 9;
		}
		while (input >= 5) {
			sb.append("V");
			input -= 5;
		}
		while (input >= 4) {
			sb.append("IV");
			input -= 4;
		}
		while (input >= 1) {
			sb.append("I");
			input -= 1;
		}
		return sb.toString();
	}
}
