package net.maunium.Maucros.Gui.KeyMaucros;

import org.lwjgl.input.Keyboard;

import com.mcf.davidee.guilib.basic.Label;
import com.mcf.davidee.guilib.core.Button;
import com.mcf.davidee.guilib.core.Container;
import com.mcf.davidee.guilib.core.Widget;
import com.mcf.davidee.guilib.vanilla.ButtonVanilla;
import com.mcf.davidee.guilib.vanilla.ScrollbarVanilla;

import mauluam.MauThreadLib;

import net.maunium.Maucros.Gui.MauScreen;
import net.maunium.Maucros.Gui.Config.GuiConfig;
import net.maunium.Maucros.Gui.Widgets.LuaThreadWidget;
import net.maunium.Maucros.Misc.I18n;

public class GuiLuaThreads extends MauScreen {
	public GuiLuaThreads(GuiConfig parent) {
		super(parent);
	}
	
	private Container c, c2;
	private ScrollbarVanilla sb;
	private ButtonVanilla back, killAll;
	private Label title;
	
	@Override
	public void onInit() {
		title = new Label(I18n.format("conf.lua.threads.title"));
		back = new ButtonVanilla(150, 20, I18n.format("conf.back"), this);
		killAll = new ButtonVanilla(150, 20, I18n.format("conf.lua.threads.killall"), this);
		
		sb = new ScrollbarVanilla(10);
		c2 = new Container(sb, 14, 12);
		
		c = new Container();
		c.addWidgets(title, back, killAll);
		
		containers.add(c);
		containers.add(c2);
	}
	
	
	@Override
	public void onReval() {
		title.setPosition(width / 2, 15);
		int y = 16;
		c2.getWidgets().clear();
		for (String s : MauThreadLib.getThreads()){
			y += 20;
			LuaThreadWidget ltw = new LuaThreadWidget(s);
			ltw.setPosition(width / 2 - ltw.getWidth() / 2, y);
			c2.addWidgets(ltw);
		}
		sb.setPosition(width - 90, 30);
		back.setPosition(width / 2 - 150 - 2, 200);
		killAll.setPosition(width / 2 + 2, 200);
		c.revalidate(0, 0, width, height);
		c2.revalidate(80, 30, width - 160, back.getY() - 35);
	}
	
	@Override
	public void onButtonClicked(Button b){
		if(b.equals(back)) close();
		else if (b.equals(killAll)){
			MauThreadLib.stopThreads();
			revalidateGui();
		}
	}
	
	@Override
	protected void mouseClicked(int mx, int my, int code) {
		if (code == 0) {
			c.mouseClicked(mx, my);
			c2.mouseClicked(mx, my);
		}
	}
	
	@Override
	public void onKeyTyped(char c, int kc){
		if(kc == Keyboard.KEY_DELETE){
			for(Widget w : c2.getWidgets()){
				if(w instanceof LuaThreadWidget){
					LuaThreadWidget ltw = (LuaThreadWidget) w;
					if(ltw.isSelected()){
						MauThreadLib.stopThread(ltw.getName());
						revalidateGui();
						return;
					}
				}
			}
		}
	}
}
