package net.maunium.Maucros.Gui.Widgets;

import com.mcf.davidee.guilib.core.Scrollbar.Shiftable;
import com.mcf.davidee.guilib.core.Widget;

import net.maunium.Maucros.Misc.GLHelper;

import net.minecraft.client.gui.Gui;

public class LuaThreadWidget extends Widget implements Shiftable {
	
	protected final String name;
	protected boolean hover, selected;
	
	public String getName(){
		return name;
	}
	
	public LuaThreadWidget(int width, int height, String name) {
		super(width, height);
		this.name = name;
	}
	
	public LuaThreadWidget(String name) {
		super(150, 15);
		this.name = name;
	}
	
	@Override
	public void draw(int mx, int my) {
		hover = inBounds(mx, my);
		Gui.drawRect(x, y, x + width, y + height, GLHelper.toInt(68, 68, 68, 155));
		this.drawString(mc.fontRendererObj, name, x + 4, y + 4, selected ? GLHelper.toInt(150, 255, 150, 255) : (hover ? GLHelper.toInt(255, 255, 185, 230) : GLHelper.toInt(255, 255, 255, 255)));
	}
	
	public boolean isSelected() {
		return selected;
	}
	
	public void setSelected(boolean selected) {
		this.selected = selected;
	}
	
	@Override
	public void shiftY(int dy) {
		this.y += dy;
	}
	
	@Override
	public boolean click(int mx, int my) {
		if (inBounds(mx, my)) {
			if (selected) selected = false;
			else selected = true;
			return true;
		} else selected = false;
		return false;
	}
}
