package net.maunium.Maucros.Listeners;

import io.netty.buffer.Unpooled;

import java.io.UnsupportedEncodingException;
import java.net.InetSocketAddress;
import java.net.SocketAddress;

import net.maunium.Maucros.Maucros;
import net.maunium.Maucros.Config.ServerInfo;
import net.maunium.Maucros.Config.Settings;

import net.minecraft.network.PacketBuffer;
import net.minecraft.network.play.client.C17PacketCustomPayload;

import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;
import net.minecraftforge.fml.common.network.FMLNetworkEvent.ClientConnectedToServerEvent;
import net.minecraftforge.fml.common.network.FMLNetworkEvent.ClientDisconnectionFromServerEvent;

public class ConnectListener {
	@SubscribeEvent
	public void onConnect(ClientConnectedToServerEvent evt) {
		Settings.disabled = false;
		SocketAddress sa = evt.manager.getRemoteAddress();
		if (sa instanceof InetSocketAddress) {
			InetSocketAddress isa = (InetSocketAddress) sa;
			ServerInfo.setCurrent(ServerInfo.valueOf((InetSocketAddress) sa));
			Maucros.getLogger().custom("Connected to " + ServerInfo.getCurrent(), "Connection", false);
		}
		
		try {
			evt.manager.sendPacket(new C17PacketCustomPayload("Maucros", new PacketBuffer(Unpooled.copiedBuffer((Maucros.name + " " + Maucros.version).getBytes("UTF-8")))));
		} catch (UnsupportedEncodingException e) {
			Maucros.printChatErrorLocalized("message.server.sendfail");
			Maucros.getLogger().catching(e);
		}
	}
	
	@SubscribeEvent
	public void onDisconnect(ClientDisconnectionFromServerEvent evt) {
		Maucros.getLogger().custom("Disconnected from " + ServerInfo.getCurrent(), "Connection", false);
		Settings.disabled = false;
		ServerInfo.clearCurrent();
	}
}
