package net.maunium.Maucros.Listeners;

import org.lwjgl.input.Keyboard;

import net.maunium.Maucros.Maucros;
import net.maunium.Maucros.Actions.ActionBlink;
import net.maunium.Maucros.Config.Settings;
import net.maunium.Maucros.KeyMaucros.KeyMaucro;
import net.maunium.Maucros.Misc.MauKeyBinds;
import net.maunium.Maucros.Misc.MaucrosLicensor;
import net.maunium.Maucros.Misc.ScreenshotTaker;

import net.minecraft.client.Minecraft;
import net.minecraft.client.entity.EntityPlayerSP;
import net.minecraft.client.gui.GuiChat;
import net.minecraft.client.gui.GuiNewChat;

import net.minecraftforge.fml.client.FMLClientHandler;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;
import net.minecraftforge.fml.common.gameevent.InputEvent.KeyInputEvent;

public class KeyInputListener {
	private Maucros host;
	
	public KeyInputListener(Maucros host) {
		this.host = host;
	}
	
	@SubscribeEvent
	public void onKeyInput(KeyInputEvent evt) {
		if (Settings.disabled) return;
		if (!MaucrosLicensor.check()) return;
		if (Keyboard.getEventKey() == Keyboard.KEY_NONE) return;
		for (KeyMaucro km : Settings.KeyMaucros.getKeyMaucros())
			if (km.getExecutionPhase().equals(KeyMaucro.ExecPhase.PRECHECKS)) if (km.checkAndExecute()) break;
		
		if (FMLClientHandler.instance().isGUIOpen(GuiChat.class)) return;
		if (Minecraft.getMinecraft().thePlayer == null) return;
		
		for (KeyMaucro km : Settings.KeyMaucros.getKeyMaucros())
			if (km.getExecutionPhase().equals(KeyMaucro.ExecPhase.PREKEYS)) if (km.checkAndExecute()) break;
		
		MauKeyBinds mkbs = host.getKeybindings();
		EntityPlayerSP p = Minecraft.getMinecraft().thePlayer;
		if (mkbs.getKeyBinding(mkbs.AUTOUSE).isPressed()) {
			if (!Settings.Enabled.autouse) Settings.Enabled.autouse = true;
			else Settings.Enabled.autouse = false;
		} else if (mkbs.getKeyBinding(mkbs.AUTOATTACK).isPressed()) {
			if (!Settings.Enabled.autoattack) Settings.Enabled.autoattack = true;
			else {
				Settings.Enabled.autoattack = false;
				Settings.Autoattack.releaseOnNextTick = true;
			}
		} else if (mkbs.getKeyBinding(mkbs.ATTACKAURA).isPressed()) {
			if (!Settings.Enabled.attackaura) Settings.Enabled.attackaura = true;
			else Settings.Enabled.attackaura = false;
		} else if (mkbs.getKeyBinding(mkbs.AUTOSOUP).isPressed()) {
			if (!Settings.Enabled.autosoup) Settings.Enabled.autosoup = true;
			else Settings.Enabled.autosoup = false;
		} else if (mkbs.getKeyBinding(mkbs.FLY).isPressed()) {
			if (Settings.Enabled.fly == 0) {
				if (Keyboard.isKeyDown(Keyboard.KEY_LSHIFT)) Settings.Enabled.fly = 2;
				else Settings.Enabled.fly = 1;
			} else {
				if (Settings.Enabled.fly == 1) {
					p.motionX = 0;
					p.motionZ = 0;
					p.motionY = 0;
				}
				Settings.Enabled.fly = 0;
			}
		} else if (mkbs.getKeyBinding(mkbs.FLYSPEED_INC).isPressed()) {
			if (Keyboard.isKeyDown(mkbs.getKeyBinding(mkbs.FLYSPEED_DEC).getKeyCode())) {
				Settings.Fly.resetSpeed();
				return;
			}
			int amount = 10;
			if (Keyboard.isKeyDown(Keyboard.KEY_Q)) {
				if (Keyboard.isKeyDown(Keyboard.KEY_R)) {
					if (Keyboard.isKeyDown(Keyboard.KEY_LSHIFT)) amount = 100;
					else amount = 50;
				} else amount = 20;
			} else if (Keyboard.isKeyDown(Keyboard.KEY_R)) if (Keyboard.isKeyDown(Keyboard.KEY_LSHIFT)) amount = 1;
			else amount = 5;
			int res = Settings.Fly.incSpeed(amount);
			if (res == 1) {
				if (Settings.Fly.getSpeed() != Settings.Fly.getMaxSpeed()) Settings.Fly.setSpeed(Settings.Fly.getMaxSpeed());
				else Maucros.printChatErrorLocalized("message.speed.toohigh", Settings.Fly.getMaxSpeed());
			} else if (res == -1) if (Settings.Fly.getSpeed() != Settings.Fly.getMinSpeed()) Settings.Fly.setSpeed(Settings.Fly.getMinSpeed());
			else Maucros.printChatErrorLocalized("message.speed.toolow", Settings.Fly.getMinSpeed());
		} else if (mkbs.getKeyBinding(mkbs.FLYSPEED_DEC).isPressed()) {
			if (Keyboard.isKeyDown(mkbs.getKeyBinding(mkbs.FLYSPEED_INC).getKeyCode())) {
				Settings.Fly.resetSpeed();
				return;
			}
			int amount = 10;
			if (Keyboard.isKeyDown(Keyboard.KEY_Q)) {
				if (Keyboard.isKeyDown(Keyboard.KEY_R)) {
					if (Keyboard.isKeyDown(Keyboard.KEY_LSHIFT)) amount = 100;
					else amount = 50;
				} else amount = 20;
			} else if (Keyboard.isKeyDown(Keyboard.KEY_R)) if (Keyboard.isKeyDown(Keyboard.KEY_LSHIFT)) amount = 1;
			else amount = 5;
			int res = Settings.Fly.decSpeed(amount);
			if (res == 1) {
				if (Settings.Fly.getSpeed() != Settings.Fly.getMaxSpeed()) Settings.Fly.setSpeed(Settings.Fly.getMaxSpeed());
				else Maucros.printChatErrorLocalized("message.speed.toohigh", Settings.Fly.getMaxSpeed());
			} else if (res == -1) if (Settings.Fly.getSpeed() != Settings.Fly.getMinSpeed()) Settings.Fly.setSpeed(Settings.Fly.getMinSpeed());
			else Maucros.printChatErrorLocalized("message.speed.toolow", Settings.Fly.getMinSpeed());
		} else if (mkbs.getKeyBinding(mkbs.SPAMMER).isPressed()) {
			if (!Settings.Enabled.spammer) {
				Settings.Enabled.spammer = true;
				GuiNewChat gnc = Minecraft.getMinecraft().ingameGUI.getChatGUI();
				if (gnc.getSentMessages().size() != 0) host.getActions().spammer.spam = (String) gnc.getSentMessages().get(gnc.getSentMessages().size() - 1);
			} else Settings.Enabled.spammer = false;
		} else if (mkbs.getKeyBinding(mkbs.CONFIG).isPressed()) {
			if (!Minecraft.getMinecraft().inGameHasFocus) return;
			if (Settings.Enabled.gui) net.maunium.Maucros.Gui.MaucrosGuiHandler.openGui(1);
			else Maucros.printChatErrorLocalized("message.missing.guilib");
		} else if (mkbs.getKeyBinding(mkbs.ITEMSPAWNER).isPressed()) {
			if (!Minecraft.getMinecraft().inGameHasFocus) return;
			if (Settings.Enabled.gui) net.maunium.Maucros.Gui.MaucrosGuiHandler.openGui(3);
			else Maucros.printChatErrorLocalized("message.missing.guilib");
		} else if (mkbs.getKeyBinding(mkbs.BLINK).isPressed()) {
			if (Settings.Enabled.blink) ActionBlink.releaseBlink();
			else ActionBlink.startBlinking();
		} else if (mkbs.getKeyBinding(mkbs.PLAYERESP).isPressed()) {
			if (Settings.Enabled.playerESP) Settings.Enabled.playerESP = false;
			else Settings.Enabled.playerESP = true;
		} else if (mkbs.getKeyBinding(mkbs.TRACER).isPressed()) {
			if (Settings.Enabled.tracer) Settings.Enabled.tracer = false;
			else Settings.Enabled.tracer = true;
		} else if (mkbs.getKeyBinding(mkbs.NOFALL).isPressed()) {
			if (Settings.Enabled.nofall) Settings.Enabled.nofall = false;
			else Settings.Enabled.nofall = true;
		} else if (mkbs.getKeyBinding(mkbs.AIMBOT).isPressed()) {
			if (Settings.Enabled.aimbot) Settings.Enabled.aimbot = false;
			else Settings.Enabled.aimbot = true;
		} else if (mkbs.getKeyBinding(mkbs.CALCULATOR).isPressed()) {
			if (Settings.Enabled.calculator) {
				Settings.Enabled.calculator = false;
				Maucros.printChatLocalized("message.calculator.off");
			} else {
				Settings.Enabled.calculator = true;
				Maucros.printChatLocalized("message.calculator.on");
			}
		} else if (mkbs.getKeyBinding(mkbs.XRAY).isPressed()) {
			if (Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) && Settings.Enabled.gui) net.maunium.Maucros.Gui.MaucrosGuiHandler.openGui(5);
			else {
				if (Settings.Enabled.xray) Settings.Enabled.xray = false;
				else Settings.Enabled.xray = true;
				
				Minecraft.getMinecraft().renderGlobal.loadRenderers();
			}
		} else if (mkbs.getKeyBinding(mkbs.FREECAM).isPressed()) {
			if (Settings.Enabled.freecam) host.getActions().freecam.disable();
			else host.getActions().freecam.enable();
		} else if (mkbs.getKeyBinding(mkbs.TRAJECTORIES).isPressed()) {
			if (Settings.Enabled.trajectories) Settings.Enabled.trajectories = false;
			else Settings.Enabled.trajectories = true;
		} else if (mkbs.getKeyBinding(mkbs.FULLBRIGHT).isPressed()) {
			if (Settings.Enabled.fullbright) {
				Settings.Enabled.fullbright = false;
				Minecraft.getMinecraft().gameSettings.gammaSetting = 1.0F;
			} else Settings.Enabled.fullbright = true;
		} else if (mkbs.getKeyBinding(mkbs.SCREENSHOT).isPressed()) ScreenshotTaker.capture();
		else if (mkbs.getKeyBinding(mkbs.PHASE).isPressed()) host.getActions().phase.execute();
		for (KeyMaucro km : Settings.KeyMaucros.getKeyMaucros())
			if (km.getExecutionPhase().equals(KeyMaucro.ExecPhase.POSTKEYS)) if (km.checkAndExecute()) break;
	}
}
