package net.maunium.Maucros.Listeners;

import java.nio.charset.StandardCharsets;

import org.apache.commons.codec.binary.Base64;
import org.jasypt.encryption.StandardPBEStringEncryptor;
import org.jasypt.salt.StringFixedSaltGenerator;

import net.maunium.MauEventLib.ClientChatSendEvent;
import net.maunium.Maucros.Maucros;
import net.maunium.Maucros.Config.Settings;
import net.maunium.Maucros.Misc.Calculator;

import net.minecraftforge.fml.common.eventhandler.EventPriority;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;

public class OutChatListener {
	@SuppressWarnings("deprecation")
	@SubscribeEvent(priority = EventPriority.HIGH)
	public void onSendChat(ClientChatSendEvent evt) {
		if (Settings.disabled) return;
		String m = evt.getMessage().toLowerCase();
		if (m.startsWith("b64 ") || m.startsWith("base64 ")) {
			String s = evt.getMessage().split(" ", 2)[1];
			String encoded = new String(Base64.encodeBase64(s.getBytes(StandardCharsets.UTF_8)), StandardCharsets.UTF_8);
			String msg = "TUFVQjY0" + encoded;
			if(msg.length() > 100){
				Maucros.printChatErrorLocalized("message.encoding.toolong", msg.length());
				evt.setCanceled(true);
				return;
			}
			evt.setMessage(msg);
			return;
		} else if (m.startsWith("enc ")) {
			String s = evt.getMessage().split(" ", 2)[1];
			StandardPBEStringEncryptor enc = new StandardPBEStringEncryptor();
			enc.setStringOutputType(Settings.Encryption.base64 ? "base64" : "hexadecimal");
			enc.setPassword(Settings.Encryption.password);
			enc.setSaltGenerator(new StringFixedSaltGenerator(Settings.Encryption.salt));
			enc.setAlgorithm("PBEWithMD5AndTripleDES");
			String msg = "B5D3S" + enc.encrypt(s);
			if(msg.length() > 100){
				Maucros.printChatErrorLocalized("message.encryption.toolong", msg.length());
				evt.setCanceled(true);
				return;
			}
			evt.setMessage(msg);
			return;
		} else if (m.startsWith("#calculate ") || m.startsWith("#calc ") || m.startsWith("#calculator ")) {
			evt.setCanceled(true);
			String s = Calculator.processCalculation(evt.getMessage().split(" ", 2)[1]);
			if (s.equals("varname")) Maucros.printChatErrorLocalized("message.calculator.variable.spacename");
			else if (!s.equals("syntax")) Maucros.printChat(s);
			return;
		} else if (Settings.Enabled.calculator) {
			evt.setCanceled(true);
			String s = Calculator.processCalculation(evt.getMessage());
			if (s.equals("varname")) Maucros.printChatErrorLocalized("message.calculator.variable.spacename");
			else if (!s.equals("syntax")) Maucros.printChat(s);
			return;
		}
		
		if (s == null) {
			evt.setCanceled(true);
			s = evt.getMessage();
		}
//		if (!Settings.MauChat.enabled) return;
//		if (m.startsWith("#help")) {
//			ChatStyle sstyle = new ChatStyle().setColor(EnumChatFormatting.AQUA).setBold(true);
//			IChatComponent hashtag = new ChatComponentText("#").setChatStyle(new ChatStyle().setColor(EnumChatFormatting.AQUA));
//			ChatStyle estyle = new ChatStyle().setColor(EnumChatFormatting.GRAY);
//			Maucros.printChatLocalized("message.mauchat.help.title", AdaptedChatClient.version);
//			IChatComponent connect = hashtag.createCopy().appendSibling(new ChatComponentText("Connect").setChatStyle(sstyle))
//					.appendSibling(new ChatComponentText(" - " + I18n.format("message.mauchat.help.connect")).setChatStyle(estyle));
//			IChatComponent input = hashtag.createCopy().appendSibling(new ChatComponentText("Input").setChatStyle(sstyle))
//					.appendSibling(new ChatComponentText(" - " + I18n.format("message.mauchat.help.input")).setChatStyle(estyle));
//			IChatComponent chat = hashtag.createCopy().appendSibling(new ChatComponentText("Input").setChatStyle(sstyle))
//					.appendSibling(new ChatComponentText(" - " + I18n.format("message.mauchat.help.chat")).setChatStyle(estyle));
//			ChatLogger.printChatNoLog(connect);
//			ChatLogger.printChatNoLog(input);
//			ChatLogger.printChatNoLog(chat);
//			evt.setCanceled(true);
//		} else if (m.startsWith("#connect")) {
//			Thread mc = new Thread() {
//				@Override
//				public void run() {
//					try {
//						Settings.MauChat.create();
//						Settings.MauChat.inputToMauchat = true;
//						if (Settings.MauChat.port == 29350) Maucros.printChatLocalized("message.mauchat.connected", Settings.MauChat.ip);
//						else Maucros.printChatLocalized("message.mauchat.connected", Settings.MauChat.ip + ":" + Settings.MauChat.port);
//						
//						if (Settings.MauChat.autologin()) Settings.MauChat.login();
//					} catch (Exception e) {
//						Maucros.getLogger().catching(e);
//						if (Settings.MauChat.port == 29350) Maucros.printChatErrorLocalized("message.mauchat.connectfail", Settings.MauChat.ip);
//						else Maucros.printChatErrorLocalized("message.mauchat.connectfail", Settings.MauChat.ip + ":" + Settings.MauChat.port);
//					}
//				}
//			};
//			mc.setName("MauChat Connector");
//			mc.start();
//			evt.setCanceled(true);
//		} else if (m.startsWith("#input")) {
//			if (Settings.MauChat.inputToMauchat) {
//				Settings.MauChat.inputToMauchat = false;
//				Maucros.printChatLocalized("message.mauchat.input.server");
//			} else {
//				Settings.MauChat.inputToMauchat = true;
//				Maucros.printChatLocalized("message.mauchat.input.mauchat");
//			}
//			evt.setCanceled(true);
//		} else if (m.startsWith("#chat")) {
//			if (Settings.MauChat.onlyShowMauchat) {
//				Settings.MauChat.onlyShowMauchat = false;
//				Maucros.printChatLocalized("message.mauchat.show.both");
//			} else {
//				Settings.MauChat.onlyShowMauchat = true;
//				Maucros.printChatLocalized("message.mauchat.show.mauchat");
//			}
//			evt.setCanceled(true);
//		} else if (Settings.MauChat.inputToMauchat && Settings.MauChat.isConnected() && AdaptedInputReader.getInstance() != null) {
//			if (msg.startsWith("**")) {
//				msg = msg.substring(1);
//				if (msg.startsWith("/")) AdaptedInputReader.getInstance().handleCommand(msg.substring(1));
//				else AdaptedInputReader.getInstance().handleChat(msg);
//				evt.setCanceled(true);
//			} else if (msg.startsWith("*")) evt.setMessage(msg.substring(1));
//			else {
//				if (msg.startsWith("/")) AdaptedInputReader.getInstance().handleCommand(msg.substring(1));
//				else AdaptedInputReader.getInstance().handleChat(msg);
//				evt.setCanceled(true);
//			}
//		} else if (msg.startsWith("**")) evt.setMessage(msg.substring(1));
//		else if (msg.startsWith("*") && AdaptedInputReader.getInstance() != null) {
//			msg = msg.substring(1);
//			if (msg.startsWith("/")) AdaptedInputReader.getInstance().handleCommand(msg.substring(1));
//			else AdaptedInputReader.getInstance().handleChat(msg);
//			evt.setCanceled(true);
//		}
		Maucros.getChatLogger().out(evt.getMessage());
	}
	
	private volatile String s = "";
	
	public synchronized String readString() {
		s = null;
		while (s == null)
			try {
				Thread.sleep(10);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		String rtrn = new String(s.getBytes());
		s = "";
		return rtrn;
	}
}
