package net.maunium.Maucros.Listeners;

import java.util.List;

import net.maunium.Maucros.Config.Settings;
import net.maunium.Maucros.Misc.EntityFreecam;
import net.maunium.Maucros.Misc.GLHelper;
import net.maunium.Maucros.Misc.Trajectories;

import net.minecraft.client.Minecraft;
import net.minecraft.client.entity.EntityPlayerSP;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.util.AxisAlignedBB;

import net.minecraftforge.client.event.RenderWorldLastEvent;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;

public class WorldRenderListener {
	@SubscribeEvent
	public void onWorldRender(RenderWorldLastEvent evt) {
		if (Settings.disabled) return;
		EntityPlayerSP p = Minecraft.getMinecraft().thePlayer;
		if (Settings.Enabled.playerESP) for (EntityPlayer e : (List<EntityPlayer>) Minecraft.getMinecraft().theWorld.playerEntities) {
			if (e.equals(p) || e instanceof EntityFreecam) continue;
			
			float hW = e.width / 2.0F;
			AxisAlignedBB bb = AxisAlignedBB.fromBounds(e.posX - hW, e.posY, e.posZ - hW, e.posX + hW, e.posY + 1.68, e.posZ + hW);
			
			if (Settings.Friends.isFriend(e.getName())) GLHelper.drawBoundingBox(bb, 0.1, 0.7, 0.1);
			else GLHelper.drawBoundingBox(bb, 0.7, 0.1, 0.1);
		}
		if (Settings.Enabled.tracer) {
			for (EntityPlayer e : (List<EntityPlayer>) Minecraft.getMinecraft().theWorld.playerEntities) {
				if (e.equals(p) || e instanceof EntityFreecam) continue;
				if (Settings.Friends.isFriend(e.getName())) GLHelper.drawLine(p.posX, p.posY, p.posZ, p.posX, p.posY + p.getEyeHeight(), p.posZ, e.posX, e.posY + e.getEyeHeight(), e.posZ, 2, 0, 255, 0, 1.0F);
				else GLHelper.drawLine(p.posX, p.posY, p.posZ, p.posX, p.posY + p.getEyeHeight(), p.posZ, e.posX, e.posY + e.getEyeHeight(), e.posZ, 2, 255, 0, 0, 1.0F);
			}
		}
		if (Settings.Enabled.trajectories) Trajectories.render();
	}
}
