package net.maunium.Maucros.MauChat;

import java.io.IOException;

import net.maunium.MauChat.Packet;
import net.maunium.Maucros.Config.Settings;

/**
 * An adapted version of the MauChat SocketReader class
 * @author Tulir293
 * @since Unknown 1.2 developement version
 */
public class AdaptedSocketReader extends Thread {
	private boolean running;
	private AdaptedChatClient host;
	
	public AdaptedSocketReader() {
		host = Settings.MauChat.getInstance();
		setName("MauChat CSR");
	}
	
	public void stopThread() {
		running = false;
		// this.interrupt();
	}
	
	@Override
	public void run() {
		running = true;
		
		synchronized (this) {
			while (running) {
				Packet p;
				try {
					p = Packet.readPacket(host.getIn());
				} catch (IOException e1) {
					running = false;
					break;
				}
				if (p == null) running = false;
				if (!running) break;
				if (p.id == Packet.CHAT) host.println(p.getData());
				else if (p.id == Packet.KICKED) {
					host.println(p.getData());
					try {
						host.close();
					} catch (IOException e) {
						e.printStackTrace();
					}
				} else if (p.id == Packet.SERVER_MESSAGE) host.println("[Server] " + p.getData());
				else host.errorln("Unexpected packet from server. ID " + p.id + ", Data: " + p.getData());
			}
		}
	}
}
