package net.maunium.Maucros.Misc;

import net.minecraft.util.ChatComponentText;
import net.minecraft.util.ChatStyle;
import net.minecraft.util.EnumChatFormatting;
import net.minecraft.util.IChatComponent;

public class ChatHelper {
	
	public static final int NONE = 0, BOLD = 1, ITALIC = 2, UNDERLINED = 4, OBFUSCATED = 8;
	
	public static IChatComponent createComponent(Object message){
		return new ChatComponentText(message.toString());
	}
	
	public static IChatComponent setColor(IChatComponent comp, EnumChatFormatting color){
		return setStyle(comp, comp.getChatStyle().setColor(color));
	}
	
	public static IChatComponent append(IChatComponent comp, Object message){
		return append(comp, message, null, 0);
	}
	
	public static IChatComponent append(IChatComponent comp, Object message, EnumChatFormatting color, int otherformat){
		ChatStyle cs = new ChatStyle();
		if(color != null) cs = cs.setColor(color);
		if((otherformat & BOLD) > 0) cs = cs.setBold(true);
		if((otherformat & ITALIC) > 0) cs = cs.setItalic(true);
		if((otherformat & UNDERLINED) > 0) cs = cs.setUnderlined(true);
		if((otherformat & OBFUSCATED) > 0) cs = cs.setObfuscated(true);
		return comp.appendSibling(new ChatComponentText(message.toString()).setChatStyle(cs));
				
	}
	
	public static IChatComponent setStyle(IChatComponent comp, ChatStyle style){
		return comp.setChatStyle(style);
	}
}
