package net.maunium.Maucros.Misc;

import net.minecraft.client.entity.AbstractClientPlayer;
import net.minecraft.client.entity.EntityPlayerSP;
import net.minecraft.item.ItemStack;
import net.minecraft.util.DamageSource;
import net.minecraft.util.IChatComponent;
import net.minecraft.util.MathHelper;
import net.minecraft.util.MovementInput;

/**
 * The Freecam Entity used by the Freecam mode.
 * 
 * @author Tulir293
 * @since 1.4 Beta 2
 */
public class EntityFreecam extends AbstractClientPlayer {
	
	private boolean isItemInUse;
//	 private int otherPlayerMPPosRotationIncrements;
//	 private double x, y, z;
//	 private float yaw, pitch;
	public MovementInput movementInput = null;
	
	public EntityFreecam(EntityPlayerSP p) {
		super(p.worldObj, p.getGameProfile());
		this.jumpMovementFactor = p.jumpMovementFactor;
		this.stepHeight = p.stepHeight;
		// this.field_71082_cx = 0.25F;
		this.renderDistanceWeight = 10.0D;
	}
	
	@Override
	public boolean attackEntityFrom(DamageSource ds, float f) {
		return true;
	}
	
	@Override
	public boolean hasSkin() {
		return false;
	}
	
//	@Override
//	public void setPositionAndRotation(double x, double y, double z, float yaw, float pitch) {
//		this.x = x;
//		this.y = y;
//		this.z = z;
//		this.yaw = yaw;
//		this.pitch = pitch;
//	}
	
	public void setMovementInput(MovementInput mi) {
		this.movementInput = mi;
		this.moveEntityWithHeading(mi.moveStrafe, mi.moveForward);
	}
	
	@Override
	public void moveEntity(double x, double y, double z) {
		onGround = true;
		this.setEntityBoundingBox(this.getEntityBoundingBox().offset(x, y, z));
		this.posX = (this.getEntityBoundingBox().minX + this.getEntityBoundingBox().maxX) / 2.0D;
		this.posY = this.getEntityBoundingBox().minY;
		this.posZ = (this.getEntityBoundingBox().minZ + this.getEntityBoundingBox().maxZ) / 2.0D;
		onGround = true;
	}
	
	@Override
	public boolean isSneaking() {
		return false;
	}
	
	@Override
	public boolean isInvisible() {
		return false;
	}
	
	@Override
	public boolean isSprinting() {
		return false;
	}
	
	/**
	 * Called to update the entity's position/logic.
	 */
	@Override
	public void onUpdate() {
//		this.field_71082_cx = 0.0F;
		super.onUpdate();
		this.prevLimbSwingAmount = this.limbSwingAmount;
		double d0 = this.posX - this.prevPosX;
		double d1 = this.posZ - this.prevPosZ;
		float f = MathHelper.sqrt_double(d0 * d0 + d1 * d1) * 4.0F;
		
		if (f > 1.0F) f = 1.0F;
		
		this.limbSwingAmount += (f - this.limbSwingAmount) * 0.4F;
		this.limbSwing += this.limbSwingAmount;
		
		if (!this.isItemInUse && this.isEating() && this.inventory.mainInventory[this.inventory.currentItem] != null) {
			ItemStack itemstack = this.inventory.mainInventory[this.inventory.currentItem];
			this.setItemInUse(this.inventory.mainInventory[this.inventory.currentItem], itemstack.getItem().getMaxItemUseDuration(itemstack));
			this.isItemInUse = true;
		} else if (this.isItemInUse && !this.isEating()) {
			this.clearItemInUse();
			this.isItemInUse = false;
		}
	}
	
//	@Override
//	public void onLivingUpdate() {
//		super.onLivingUpdate();
//	}
	
	@Override
	public boolean isSpectator() {
		return false;
	}
	
	@Override
	public void setCurrentItemOrArmor(int i, ItemStack is) {
		if (i == 0) this.inventory.mainInventory[this.inventory.currentItem] = is;
		else this.inventory.armorInventory[i - 1] = is;
	}
	
	@Override
	public float getEyeHeight() {
		return 1.62F;
	}
	
	@Override
	public void addChatMessage(IChatComponent icc) {}
	
	@Override
	public boolean canUseCommand(int i, String s) {
		return false;
	}
}