package net.maunium.Maucros.Misc;

import org.lwjgl.input.Keyboard;

import scala.actors.threadpool.Arrays;

import net.minecraft.client.settings.KeyBinding;
import net.minecraft.crash.CrashReport;
import net.minecraft.crash.CrashReportCategory;
import net.minecraft.util.ReportedException;

import net.minecraftforge.fml.client.registry.ClientRegistry;

public class MauKeyBinds {
	private final KeyBinding[] keys;
	
	public final int CONFIG = 0, AUTOUSE = 1, AUTOATTACK = 2, ATTACKAURA = 3, AUTOSOUP = 4, FLY = 5, FLYSPEED_INC = 6, FLYSPEED_DEC = 7, SPAMMER = 8,
			USERNAME = 9, BLINK = 10, PHASE = 11, PLAYERESP = 12, TRACER = 13, NOFALL = 14, AIMBOT = 15, CALCULATOR = 16, XRAY = 17, FREECAM = 18,
			TRAJECTORIES = 19, ITEMSPAWNER = 20, FULLBRIGHT = 21, SCREENSHOT = 22;
	private final String[] categories = { "maukey.categories.tools", "maukey.categories.hacks" };
	private final int[] categoryFor = { 0, 0, 0, 1, 1, 0, 0, 0, 1, 0, 1, 1, 1, 1, 1, 1, 0, 1, 0, 1, 0, 0, 0 };
	private final String[] desc = { "maukey.config", "maukey.autouse", "maukey.autoattack", "maukey.attackaura", "maukey.autosoup", "maukey.amov",
			"maukey.speedhackinc", "maukey.speedhackdec", "maukey.spammer", "maukey.username", "maukey.blink", "maukey.phase", "maukey.playeresp",
			"maukey.tracer", "maukey.nofall", "maukey.aimbot", "maukey.calculator", "maukey.xray", "maukey.freecam", "maukey.trajectories",
			"maukey.itemspawner", "maukey.fullbright", "maukey.screenshot" };
	private final int[] def = { Keyboard.KEY_F4, Keyboard.KEY_PERIOD, Keyboard.KEY_COMMA, Keyboard.KEY_L, Keyboard.KEY_H, Keyboard.KEY_F, Keyboard.KEY_PRIOR,
			Keyboard.KEY_NEXT, Keyboard.KEY_INSERT, Keyboard.KEY_U, Keyboard.KEY_B, Keyboard.KEY_V, Keyboard.KEY_NONE, Keyboard.KEY_NONE, Keyboard.KEY_M,
			Keyboard.KEY_G, Keyboard.KEY_J, Keyboard.KEY_X, Keyboard.KEY_Y, Keyboard.KEY_O, Keyboard.KEY_I, Keyboard.KEY_C, Keyboard.KEY_NONE };
	
	public MauKeyBinds() {
		keys = new KeyBinding[desc.length];
		if (desc.length != def.length || desc.length != categoryFor.length) {
			Exception e = new ArrayIndexOutOfBoundsException("Key bind data arrays have different sizes");
			CrashReport crash = CrashReport.makeCrashReport(e, "Initializing Maucros Keybindings");
			CrashReportCategory crc = crash.makeCategory("Initializing Maucros Keybindings");
			crc.addCrashSection("Length of array \"desc\": ", desc.length);
			crc.addCrashSection("Length of array \"def\": ", def.length);
			crc.addCrashSection("Length of array \"categoryFor\": ", categoryFor.length);
			crc.addCrashSection("Contents of array \"desc\": ", Arrays.toString(desc));
			crc.addCrashSection("Contents of array \"def\": ", Arrays.toString(def));
			crc.addCrashSection("Contents of array \"categoryFor\": ", Arrays.toString(categoryFor));
			crc.addCrashSection("Contents of array \"categories\": ", Arrays.toString(categories));
			throw new ReportedException(crash);
		}
		for (int i = 0; i < desc.length; i++) {
			keys[i] = new KeyBinding(desc[i], def[i], categories[categoryFor[i]]);
			ClientRegistry.registerKeyBinding(keys[i]);
		}
	}
	
	/**
	 * Get a key binding using the local key code.
	 * 
	 * @return The key binding, or null if localKeyCode is out of bounds.
	 */
	public KeyBinding getKeyBinding(int localKeyCode) {
		if (checkLKC(localKeyCode)) return keys[localKeyCode];
		else return null;
	}
	
	public int getPublicKeyCode(int localKeyCode) {
		if (checkLKC(localKeyCode)) return keys[localKeyCode].getKeyCode();
		else return Keyboard.KEY_NONE;
	}
	
	public String getCategoryFor(int localKeyCode) {
		if (checkLKC(localKeyCode)) return categories[categoryFor[localKeyCode]];
		else return "Local Key Code out of bounds";
	}
	
	public String getDesc(int localKeyCode) {
		if (checkLKC(localKeyCode)) return desc[localKeyCode];
		else return "Local Key Code out of bounds";
	}
	
	public int getDefaultKeyCode(int localKeyCode) {
		if (checkLKC(localKeyCode)) return def[localKeyCode];
		else return Keyboard.KEY_NONE;
	}
	
	private boolean checkLKC(int lkc) {
		if (lkc > -1 && lkc < keys.length) return true;
		else return false;
	}
}
